package Source::Bundle::Dir;

use Carp;
use strict;
use warnings;

use Source::Bundle;
our @ISA=qw/Source::Bundle/;

sub new {
    my $class = shift;
    my $self=$class->SUPER::new(@_);
    my $file = $self->{-file};
    Carp::croak "SourceDir: not a directory $file:\n" if not -d $file;
    bless $self, $class;
    return $self;
}

sub extract {
    my ($self, $list)=@_;
    return $self->{-file};
}

sub filelist_cmd {
    my ($self,$file)=@_;
    return "find '$file' -type f";
}

sub filelist {
    my ($self)=@_;
    my $listref=$self->{-filelist};
    return $listref if $listref;
    my @filelist;
    my $file=$self->{-file};
    my $listcmd=$self->filelist_cmd($file);
    if ($listcmd) {
	open (my $fn, "$listcmd |") || die "can't run $listcmd: $!";
	while (<$fn>) {
	    chomp;
	    s!^\Q$file\E/!!;
	    push @filelist, $_;
	}
	close $fn;
    }
    $self->{-filelist}=\@filelist;
    return \@filelist;
}



1;
